##############################################################################
#
# Copyright (c) 2010 ViFiB SARL and Contributors.
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################


import socket
import urlparse
import base64


def parseUrl(url):
  info_dict = {}
  parsed_url = urlparse.urlparse(url)
  info_dict['header_dict'] = {'Content-Type': 'application/json'}
  user = parsed_url.username
  passwd = parsed_url.password
  if user is not None:
    authentication_string = '%s:%s' % (user, passwd)
    base64string = base64.encodestring(authentication_string).strip()
    info_dict['header_dict']['Authorization'] = 'Basic %s' %\
      base64string

  info_dict['path'] = parsed_url.path
  info_dict['host'] = parsed_url.hostname
  info_dict['scheme'] = parsed_url.scheme
  info_dict['port'] = parsed_url.port or \
                          socket.getservbyname(parsed_url.scheme)
  info_dict['simple_url'] = "%s://%s:%s%s" % \
                                (info_dict.get('scheme'),
                                 info_dict.get('host'),
                                 info_dict.get('port'),
                                 info_dict.get('path'))
  return info_dict

